stages:
  - test
  - build
  - build_docker
  - release
image: "rust:1.77-bullseye@sha256:4cb856969822501a4c839dadae7a4786e11293ee93efb93b6a91a0c0fc640b89"

variables:
  DOCKER_DRIVER: overlay2
  VERSION: "1.0.0"
  RUST_VERSION: "1.63"
  SOLANA_VERSION: "v1.10"
services:
  - docker:dind@sha256:c8d3a4b0f8c9f09c8d220fc68028a401f5b7f5c159a7dd62fc0915f8617ea66f


# Optional: Install a C compiler, cmake and git into the container.
# You will often need this when you (or any of your dependencies) depends on C code.

# Use cargo to test the project

test:
  stage: test
  tags:
    - xlarge
    - kubernetes
    - mgmt-nonprod
  before_script:
    - apt-get update -yqq
    #- apt-get install -y gcc clang cmake gcc-multilib make linux-kernel-headers perl bzip2 dkms build-essential git libftdi1-dev libudev-dev libclang-dev libgcc-8-dev
    - apt-get install -y gcc clang cmake make perl bzip2 dkms build-essential git libftdi1-dev libudev-dev libclang-dev zip
    - rustup install $RUST_VERSION
    - rustup default $RUST_VERSION
    - rustup component add rustfmt
    - git clone https://github.com/blockworks-foundation/solana-accountsdb-connector.git
    - cd solana-accountsdb-connector/geyser-plugin-grpc

  script:
    - rustc --version && cargo --version  # Print version info for debugging
    - cargo test --workspace --verbose

build:
  stage: build
  tags:
    - xlarge
    - kubernetes
    - mgmt-nonprod
  before_script:
    - rustc --version && cargo --version
    - apt-get update -yqq
    - apt-get install -y build-essential cmake git libftdi1-dev libudev-dev libclang-dev zip > /dev/null
    - git clone https://github.com/rpcpool/solana-accountsdb-connector  > /dev/null
    - cd solana-accountsdb-connector
    - git checkout $SOLANA_VERSION  > /dev/null
    - rm rust-toolchain.toml
    - rustup install $RUST_VERSION
    - rustup default $RUST_VERSION
    - rustup component add rustfmt
  script:
    # - cd geyser-plugin-grpc
    - cargo build --release
    - ls target/release/
  after_script:
    - echo "JOB_ID=$CI_JOB_ID" >> job.env
  artifacts:
    paths:
      - solana-accountsdb-connector/target/release/libsolana_geyser_connector_plugin_grpc.so
      - solana-accountsdb-connector/target/release/solana-geyser-connector-raw
    expire_in: never
    reports:
      dotenv: job.env

test-docker:
  stage: build_docker
  image: docker:latest@sha256:c8d3a4b0f8c9f09c8d220fc68028a401f5b7f5c159a7dd62fc0915f8617ea66f
  needs:
    - job: build
      artifacts: true
  script:
    - docker build --no-cache .

push:docker-image:
  stage: release
  image: docker:latest@sha256:c8d3a4b0f8c9f09c8d220fc68028a401f5b7f5c159a7dd62fc0915f8617ea66f
  needs:
    - job: build
      artifacts: true
    - job: test-docker
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build --no-cache -t $CI_REGISTRY_IMAGE:$VERSION .
    - docker push $CI_REGISTRY_IMAGE:$VERSION
  only:
    - master

create:release:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest@sha256:f3dceff8dfe5d5e1c7a37d0d28bebc47669be80caa6d98d37c949f846d2e63e8
  needs:
    - job: build
      artifacts: true
  variables:
    TAG: '$CI_COMMIT_SHA'
  script:
    - echo "Create Release $TAG"
    - echo $JOB_ID
  only:
    - master
  release:
    name: 'Release $TAG'
    tag_name: '$TAG'
    ref: '$TAG'
    description: 'Release $TAG'
    assets:
      links:
        - name: "release.zip"
          url: "https://gitlab.com/Blockdaemon/solana/solana-accountsdb-builder/-/jobs/$JOB_ID/artifacts/download"
